import re, sys
from c3_except import *

class c3_cluster_list:
	def __init__(self):
		self.clusters = []
		self.node = {}

class c3_command_line:


	# matches any non whitespace word
        any_token = re.compile( r"\s*(?P<word>\S+)" )

	# matches a - or -- option
	option = re.compile( r"\s*(?P<word>--?\w+)" )
	
	c_name = re.compile( r"\s*(?P<name>[\w_\-]+)?:" );
	
	number = re.compile( r"\s*(?P<num>\d+)" );
	
	range_qual = re.compile( r"\s*-" );
	
	single = re.compile( r"\s*," );
 
	line = ""


	def __init__( self, command_line ):
		self.line = command_line

	def get_opt( self ):
		match = self.option.match( self.line )
		if match:
			line_out = ""
			line_out = match.group( "word" )
			self.line = self.line[match.end():]
		else:
			raise end_of_option( None, None )
		return line_out

	def get_opt_string( self ):
		match = self.any_token.match( self.line )
		if match:
			line_out = ""
			line_out = match.group( "word" )
			self.line = self.line[match.end():]
		elif len( self.line ) == 0:
			raise end_of_opt_string( "option needs a string", None)
		else:
			raise bad_string( "option requires a string", None )
		return line_out

	def get_clusters( self ):
		cluster_obj = c3_cluster_list()

		match = self.c_name.match( self.line )
		if not match:
			cluster_obj.clusters.append( "/default" )
			cluster_obj.node["/default"]=[]
			cluster_obj.node["/default"].append( "" )
		while match:
			self.line = self.line[match.end():]
			if match.group( "name" ):
				index = match.group( "name" )
			else:
				index = "/default"
				
			cluster_obj.clusters.append( index )

			match = self.number.match( self.line )
			cluster_obj.node[index] = []
			cluster_obj.node[index].append( "" )
			node_index = 0
			while match:
				self.line = self.line[match.end():]
				cluster_obj.node[index][node_index] = int( match.group( "num") )
				match = self.range_qual.match( self.line )
				if match:
					self.line = self.line[match.end():]
					match = self.number.match( self.line )
					start_range = cluster_obj.node[index][node_index] + 1
					end_range = int( match.group( "num" ) ) + 1
					for counter in  range( start_range, end_range ):
						node_index = node_index + 1
						cluster_obj.node[index].append( "" )
						cluster_obj.node[index][node_index] = counter
					self.line = self.line[match.end():]
				match = self.single.match( self.line )
				if match:
					self.line = self.line[match.end():]
					cluster_obj.node[index].append( "" )
					node_index = node_index + 1
					match = self.number.match( self.line )
			match = self.c_name.match( self.line )
		return cluster_obj

	def rest_of_command( self ):
		return self.line	
