import os, sys, time
from select import select

class c3_sock:
	output_pipe = None
	input_pipe = None
	timeout = 10

	def set_timeout( self, new_timeout ):
		self.timeout = new_timeout
		

	def send( self, string_to_send  ):
		length = len( string_to_send )
		string_to_send = str(length) + ':' + string_to_send
		self.output_pipe.write( string_to_send )
		self.output_pipe.flush()


	def recieve( self ):
		buffer = ""
		char_in = self.input_pipe.read( 1 )
		time_start = time.time()
		time_elapsed = 0
		while char_in != ':':
			buffer = buffer + char_in
			char_in = self.input_pipe.read( 1 )
			time_elapsed = time.time() - time_start
			if char_in != "":
				time_start = time.time()
			if char_in == "" and time_elapsed > self.timeout:
				raise 'time_out'

		length = int (buffer)
		buffer = self.input_pipe.read( length )
		time_start = time.time()
		time_elapsed = 0
		while len(buffer) < length:
			new_buffer = buffer + self.input_pipe.read( length )
			if len(new_buffer) > len(buffer):
				time_start = time.time()
				time_elapsed = 0
				buffer = new_buffer
			elif time_elapsed > self.timeout:
				raise 'time_out'
			else:
				time_elapsed = time.time() - time_start
				
		return buffer

	def close( self ):
		self.__del__()

class server_sock( c3_sock ):

	def __init__(self, command):
		self.output_pipe, self.input_pipe = os.popen2( command )


	def __del__( self ):
		self.output_pipe.close()
		self.input_pipe.close()
		
class client_sock( c3_sock ):

	def __init__(self):
		if sys.stdout == None and sys.stdin == None:
			raise 'single client only'
		self.output_pipe = sys.stdout
		self.input_pipe = sys.stdin
		sys.stdout = None
		sys.stdin = None



	def __del__( self ):
		sys.stdin = self.input_pipe
		sys.stdout = self.output_pipe
